package de.dhbwka.java.exercise.arrays;

public class MatrixSubtraction {
  private static int[][] generateRandomMatrix(int x, int y, int max) {
    int[][] matrix = new int[x][y];
    for (int i = 0; i < x; i++) {
      for (int j = 0; j < y; j++) {
        matrix[i][j] = (int) (Math.random() * max);
      }
    }
    return matrix;
  }

  private static int[][] subtractMatrix(int[][] matrix1, int[][] matrix2) {
    int[][] result = new int[matrix1.length][matrix1[0].length];
    for (int i = 0; i < matrix1.length; i++) {
      for (int j = 0; j < matrix1[0].length; j++) {
        result[i][j] = matrix1[i][j] - matrix2[i][j];
      }
    }
    return result;
  }

  public static void main(String[] args) {
    int[][] matrix1 = generateRandomMatrix(3, 4, 100);
    int[][] matrix2 = generateRandomMatrix(3, 4, 100);

    System.out.println("Matrix 1:");
    for (int i = 0; i < matrix1.length; i++) {
      for (int j = 0; j < matrix1[0].length; j++) {
        System.out.printf("%3d ", matrix1[i][j]);
      }
      System.out.println();
    }

    System.out.println("Matrix 2:");
    for (int i = 0; i < matrix2.length; i++) {
      for (int j = 0; j < matrix2[0].length; j++) {
        System.out.printf("%3d ", matrix2[i][j]);
      }
      System.out.println();
    }

    int[][] result = subtractMatrix(matrix1, matrix2);

    System.out.println("Result:");
    for (int i = 0; i < result.length; i++) {
      for (int j = 0; j < result[0].length; j++) {
        System.out.printf("%3d ", result[i][j]);
      }
      System.out.println();
    }
  }
}
