package de.dhbwka.java.exercise.classes;

public class Account {
  private long AccountNumber;
  private String AccountHolder;
  private long AccountBalance;
  private long OverdraftLimit;

  public Account(long accountNumber, String accountHolder, long accountBalance, long overdraftLimit) {
    AccountNumber = accountNumber;
    AccountHolder = accountHolder;
    AccountBalance = accountBalance;
    OverdraftLimit = overdraftLimit;
  }

  public Account(long accountNumber, String accountHolder) {
    this(accountNumber, accountHolder, 0, 0);
  }

  public long getAccountBalance() {
    return AccountBalance;
  }

  public String getAccountHolder() {
    return AccountHolder;
  }

  public long getAccountNumber() {
    return AccountNumber;
  }

  public long getOverdraftLimit() {
    return OverdraftLimit;
  }

  public void setAccountHolder(String accountHolder) {
    AccountHolder = accountHolder;
  }

  public void setOverdraftLimit(long overdraftLimit) {
    OverdraftLimit = overdraftLimit;
  }

  public void processDeposit(long amount) {
    AccountBalance += amount;
  }

  public void processPayment(long amount) {
    if (AccountBalance - amount < -OverdraftLimit) {
      System.err.println("Deckung nicht ausreichend.");
    } else {
      AccountBalance -= amount;
    }
  }

  @Override
  public String toString() {
    return "Konto Nr. " + AccountNumber + " (" + AccountHolder + ") Stand: " + AccountBalance + "ct Limit: "
        + OverdraftLimit + "ct";
  }
}
