package de.dhbwka.java.exercise.classes;

public class Complex {
  private double real;
  private double imag;

  public Complex(double real, double imag) {
    this.real = real;
    this.imag = imag;
  }

  public Complex() {
    this(0, 0);
  }

  public double getMagnitude() {
    return Math.sqrt(real * real + imag * imag);
  }

  public boolean isLessThan(Complex c) {
    return this.getMagnitude() < c.getMagnitude();
  }

  public Complex add(Complex c) {
    return new Complex(this.real + c.real, this.imag + c.imag);
  }

  public Complex sub(Complex c) {
    return new Complex(this.real - c.real, this.imag - c.imag);
  }

  public Complex mul(Complex c) {
    return new Complex(this.real * c.real - this.imag * c.imag, this.real * c.imag + this.imag * c.real);
  }

  public Complex div(Complex c) {
    return new Complex((this.real * c.real + this.imag * c.imag) / (c.real * c.real + c.imag * c.imag),
        (this.imag * c.real - this.real * c.imag) / (c.real * c.real + c.imag * c.imag));
  }

  public double getImag() {
    return imag;
  }

  public double getReal() {
    return real;
  }

  @Override
  public String toString() {
    return real + (imag >= 0 ? "+" : "") + imag + "i";
  }
}
