package de.dhbwka.java.exercise.classes;

public class Horner {
  private double[] coefficients;

  public Horner(double[] coefficients) {
    this.coefficients = coefficients;
  }

  public double getValue(double x) {
    double result = 0;

    for (int i = coefficients.length - 1; i >= 0; i--) {
      result = coefficients[i] + x * result;
    }

    return result;
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();

    for (int i = 0; i < coefficients.length; i++) {
      sb.append(coefficients[i]);

      if (i > 0) {
        sb.append("x^").append(i);
      }
      if (i < coefficients.length - 1) {
        sb.append(" + ");
      }
    }

    return sb.toString();
  }
}
