package de.dhbwka.java.exercise.classes;

import java.util.Arrays;
import java.util.Random;
import java.util.Scanner;

public class Lotto {
  private int m;
  private int n;
  private int[] tipp;
  private int[] gezogeneZahlen;
  private Random random = new Random();

  public Lotto(int m, int n) {
    this.m = m;
    this.n = n;
    this.tipp = new int[m];
    this.gezogeneZahlen = new int[m];
  }

  public void tippen() {
    Scanner scanner = new Scanner(System.in);
    for (int i = 0; i < m; i++) {
      System.out.printf("Geben Sie bitte Ihren Tipp für die %d. Zahl ein: ", i + 1);
      tipp[i] = scanner.nextInt();
      while (tipp[i] < 1 || tipp[i] > n) {
        System.out.printf("Ungültige Zahl. Geben Sie bitte Ihren Tipp für die %d. Zahl ein: ", i + 1);
        tipp[i] = scanner.nextInt();
      }
    }
    Arrays.sort(tipp);
    scanner.close();
  }

  public void tippen(int[] tipp) {
    if (tipp.length != m) {
      throw new IllegalArgumentException("Die Länge des Tipps muss " + m + " sein.");
    }
    this.tipp = Arrays.copyOf(tipp, tipp.length);
    Arrays.sort(this.tipp);
  }

  public void ziehen() {
    for (int i = 0; i < m; i++) {
      int zahl;
      do {
        zahl = random.nextInt(n) + 1;
      } while (contains(gezogeneZahlen, zahl));
      gezogeneZahlen[i] = zahl;
    }
    Arrays.sort(gezogeneZahlen);
  }

  public int richtige() {
    int count = 0;
    for (int zahl : tipp) {
      if (contains(gezogeneZahlen, zahl)) {
        count++;
      }
    }
    return count;
  }

  private boolean contains(int[] array, int value) {
    for (int i : array) {
      if (i == value) {
        return true;
      }
    }
    return false;
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Tipp: ").append(Arrays.toString(tipp)).append("\n");
    sb.append("Gezogene Zahlen: ").append(Arrays.toString(gezogeneZahlen)).append("\n");
    sb.append("Richtige: ").append(richtige());
    return sb.toString();
  }
}
