package de.dhbwka.java.exercise.classes;

import java.util.Scanner;

public class Nimmspiel {
  private String player1;
  private String player2;
  private int heap1;
  private int heap2;
  private boolean isPlayer1Turn;

  public Nimmspiel(String player1, String player2) {
    this.player1 = player1;
    this.player2 = player2;
    this.heap1 = (int) (Math.random() * 10) + 1;
    this.heap2 = (int) (Math.random() * 10) + 1;
    this.isPlayer1Turn = true;
  }

  public String toString() {
    return "Spieler: " + player1 + " und " + player2 + ", Haufen 1: " + heap1 + " Kugel(n), Haufen 2: " + heap2
        + " Kugel(n)";
  }

  public boolean isGameOver() {
    return heap1 == 0 && heap2 == 0;
  }

  public void makeMove(int heap, int balls) {
    if (heap == 1) {
      heap1 -= balls;
    } else {
      heap2 -= balls;
    }
    isPlayer1Turn = !isPlayer1Turn;
  }

  public void play() {
    Scanner scanner = new Scanner(System.in);
    while (!isGameOver()) {
      System.out.println(this);
      String currentPlayer = isPlayer1Turn ? player1 : player2;
      System.out.println("Spieler " + currentPlayer + ": Von welchem Haufen ziehen Sie Kugeln? (1 oder 2)");
      int heap = scanner.nextInt();
      System.out.println("Spieler " + currentPlayer + ": Wieviele Kugeln ziehen Sie?");
      int balls = scanner.nextInt();
      if ((heap == 1 && balls > 0 && balls <= heap1) || (heap == 2 && balls > 0 && balls <= heap2)) {
        makeMove(heap, balls);
      } else {
        System.out.println("Ungültiger Zug, bitte erneut versuchen.");
      }
    }
    scanner.close();
    System.out.println("Spiel beendet.");
    String winner = isPlayer1Turn ? player2 : player1;
    System.out.println("Gewonnen hat Spieler " + winner);
  }
}
