package de.dhbwka.java.exercise.classes;

public class Point {
  private double x;
  private double y;

  public Point() {
    this(0, 0);
  }

  public Point(double x, double y) {
    this.x = x;
    this.y = y;
  }

  public double getX() {
    return x;
  }

  public void setX(double x) {
    this.x = x;
  }

  public double getY() {
    return y;
  }

  public void setY(double y) {
    this.y = y;
  }

  @Override
  public String toString() {
    return "(" + x + ", " + y + ")";
  }

  public double distanceFromOrigin() {
    return Math.sqrt(x * x + y * y);
  }

  public Point mirrorX() {
    return new Point(x, -y);
  }

  public Point mirrorY() {
    return new Point(-x, y);
  }

  public Point mirrorOrigin() {
    return new Point(-x, -y);
  }

  public double getDistance(Point p) {
    return Math.sqrt(Math.pow(p.x - x, 2) + Math.pow(p.y - y, 2));
  }
}
