package de.dhbwka.java.exercise.classes;

public class Radio {
  private boolean on;
  private int volume;
  private double frequency;

  public Radio() {
    this.on = false;
    this.volume = 0;
    this.frequency = 85.0;
  }

  public Radio(boolean on, int volume, double frequency) {
    this.turnOn();
    this.setVolume(volume);
    this.setFrequency(frequency);
  }

  public void turnOn() {
    this.on = true;
  }

  public void turnOff() {
    this.on = false;
  }

  public void incVolume() {
    if (this.volume < 10 && this.on) {
      this.volume++;
    }
  }

  public void decVolume() {
    if (this.volume > 0 && this.on) {
      this.volume--;
    }
  }

  private void setVolume(int volume) {
    if (volume >= 0 && volume <= 10) {
      this.volume = volume;
    } else {
      this.volume = 5;
    }
  }

  public void setFrequency(double frequency) {
    if (frequency >= 85.0 && frequency <= 110.0) {
      this.frequency = frequency;
    } else {
      this.frequency = 99.9;
    }
  }

  @Override
  public String toString() {
    return "Radio " + (this.on ? "an" : "aus") + ": Freq=" + this.frequency + ", Laut=" + this.volume;
  }
}
