package de.dhbwka.java.exercise.classes.vehicles;

public class Race {
  public static void main(String[] args) {
    Vehicle[] vehicles = new Vehicle[4];
    vehicles[0] = new Bicycle(20.0);
    vehicles[1] = new Car(150.0);
    vehicles[2] = new RacingCar(200.0);
    vehicles[3] = new Ambulance(80.0, true);
    // 4 hours lead for the bike
    vehicles[0].drive(240.0);
    // 1 hour of driving for everyone
    for (int i = 0; i < vehicles.length; i++) {
      vehicles[i].drive(60);
    }
    // Output Race
    for (int i = 0; i < vehicles.length; i++) {
      System.out.println(vehicles[i].toString());
    }
  }
}

abstract class Vehicle {
  private int wheels;
  private double vmax;
  private double distance;
  private double speed;

  public Vehicle() {
    this(0, 0, 0);
  }

  public Vehicle(double speed) {
    this(0, 0, speed);
  }

  public Vehicle(int wheels, double vmax, double speed) {
    this.wheels = wheels;
    this.vmax = vmax;
    this.speed = speed;
  }

  public void setSpeed(double speed) {
    this.speed = Math.min(speed, vmax);
  }

  void setVmax(double vmax) {
    this.vmax = vmax;
  }

  public void drive(double minutes) {
    distance += speed / 60 * minutes;
  }

  @Override
  public String toString() {
    return "distance=" + distance + ", speed=" + speed + ", vmax=" + vmax + ", wheels=" + wheels;
  }
}

class Bicycle extends Vehicle {
  public Bicycle(double speed) {
    super(2, 30, speed);
  }

  public Bicycle() {
    super(2, 30, 0);
  }

  @Override
  public String toString() {
    return "Bicycle [" + super.toString() + "]";
  }
}

class Car extends Vehicle {
  public Car(double speed) {
    super(4, 140, speed);
  }

  public Car() {
    super(4, 140, 0);
  }

  @Override
  public String toString() {
    return "Car [" + super.toString() + "]";
  }
}

class RacingCar extends Car {
  public RacingCar(double speed) {
    super(speed);
    setVmax(200);
  }

  public RacingCar() {
    super();
    setVmax(200);
  }

  @Override
  public String toString() {
    return "RacingCar [" + super.toString() + "]";
  }
}

class Ambulance extends Car {
  private boolean isWailing;

  public Ambulance() {
    super();
    isWailing = false;
  }

  public Ambulance(double speed, boolean isWailing) {
    super(speed);
    this.isWailing = isWailing;
  }

  public void setWailing(boolean isWailing) {
    this.isWailing = isWailing;
  }

  @Override
  public String toString() {
    return "Ambulance [" + super.toString() + ", isWailing=" + isWailing + "]";
  }
}
