package de.dhbwka.java.exercise.methods;

import java.util.Arrays;

public class Quicksort {
  public static void sort(int[] array) {
    quicksort(array, 0, array.length - 1);
  }

  public static void quicksort(int[] array, int left, int right) {
    if (left < right) {
      int pivot = partition(array, left, right);
      quicksort(array, left, pivot - 1);
      quicksort(array, pivot + 1, right);
    }
  }

  public static int partition(int[] array, int left, int right) {
    int i = left;
    int j = right - 1;
    int pivot = array[right];

    do {
      while (array[i] <= pivot && i < right) {
        i++;
      }
      while (array[j] >= pivot && j > left) {
        j--;
      }
      if (i < j) {
        int temp = array[i];
        array[i] = array[j];
        array[j] = temp;
      }
    } while (i < j);

    if (array[i] > pivot) {
      int temp = array[i];
      array[i] = pivot;
      array[right] = temp;
    }

    return i;
  }

  public static void main(String[] args) {
    int[] array = { 3, 6, 8, 10, 1, 2, 1 };
    sort(array);
    System.out.print("Sorted array: " + Arrays.toString(array));
  }
}
