package de.dhbwka.java.exercise.ui;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

import java.awt.*;
import javax.swing.*;
import javax.swing.filechooser.*;

public class TextfileViewer {
  public static void main(String[] args) {
    new TextfileViewer();
  }

  public TextfileViewer() {
    initComponents();
  }

  private void initComponents() {
    JFileChooser fc = new javax.swing.JFileChooser();
    fc.setFileFilter(new FileFilter() {
      @Override
      public boolean accept(File f) {
        return f.isDirectory() ||
            f.getName().toLowerCase().endsWith(".txt");
      }

      @Override
      public String getDescription() {
        return "Text Files";
      }
    });
    int state = fc.showOpenDialog(null);
    if (state == JFileChooser.APPROVE_OPTION) {
      this.openFile(fc.getSelectedFile(), "labels");
      this.openFile(fc.getSelectedFile(), "textArea");
    } else {
      this.error("No file selected");
    }
  }

  private void openFile(File file, String mode) {
    JFrame frame = new JFrame("Textfile Viewer - " + file.getName());
    frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
    frame.setLocationRelativeTo(null);

    if (mode.equals("labels")) {

      JPanel panel = new JPanel();
      panel.setLayout(new GridLayout(10, 1, 2, 2));
      try (BufferedReader br = new BufferedReader(new FileReader(file))) {
        String line;
        int i = 0;
        while ((line = br.readLine()) != null && i++ < 10) {
          JLabel label = new JLabel(line);
          panel.add(label);
        }
      } catch (IOException e) {
        e.printStackTrace();
      }

      frame.add(panel);
      frame.setSize(400, 300);
      frame.setVisible(true);
    } else if (mode.equals("textArea")) {
      JTextArea textArea = new JTextArea();
      textArea.setEditable(false);
      try (BufferedReader br = new BufferedReader(new FileReader(file))) {
        String line;
        while ((line = br.readLine()) != null) {
          textArea.append(line + "\n");
        }
      } catch (IOException e) {
        e.printStackTrace();
      }

      JScrollPane scrollPane = new JScrollPane(textArea);
      frame.add(scrollPane);
      frame.setSize(400, 300);
      frame.setVisible(true);
    }
  }

  private void error(String message) {
    JOptionPane.showMessageDialog(null, message, "Error", JOptionPane.ERROR_MESSAGE);
  }
}
